<script setup>
import AuthenticatedLayout from '@/Layouts/AuthenticatedLayout.vue';

import { Head, Link, useForm } from '@inertiajs/vue3';
import { showFlashMessage } from '@/global_func.js';




</script>

<template>
    <Head title="Dashboard" />

    <AuthenticatedLayout :user="user">
        <div class="container-fluid">

            <!-- Page Heading -->
            <h1 class="h3 mb-2 text-gray-800">Tambah Pesanan</h1>
            <p class="mb-4">Lakukan penambahan pesanan dengan mengisi form dibawah ini.</p>

            <!-- DataTales Example -->
            <div class="card border-0 mb-4">
                <div class="card-header bg-white py-3 d-flex justify-content-between align-items-center">
                    <h6 class="m-0 font-weight-bold text-primary">Data Pesanan</h6>
                    <Link href="/pesanan" class="btn btn-light"> <i class="fas fa-arrow-left"></i></Link>
                </div>
                <div class="card-body">
                    <!-- MultiStep Form -->
                    <div class="row justify-content-center mt-0">
                        <div class="col-lg-12 text-center p-0 mt-3 mb-2">
                            <div class="card shadow-none px-0 pt-4 pb-0 mt-3 mb-3">
                                <h2><strong>Tambah data pesanan</strong></h2>
                                <p>lengkapi data sebelum lanjutkan kehalaman berikutnya</p>
                                <div class="row">
                                    <div class="col-md-12 mx-0">
                                        <form id="msform">
                                            <!-- progressbar -->
                                            <ul id="progressbar">
                                                <li class="active" id="pelanggan"><strong>Pelanggan</strong></li>
                                                <li id="produk"><strong>Produk</strong></li>
                                                <li id="deadline"><strong>Deadline</strong></li>
                                                <li id="pembayaran"><strong>Pembayaran</strong></li>
                                                <li id="confirm"><strong>Finish</strong></li>
                                            </ul>
                                            <!-- fieldsets -->
                                            <fieldset>
                                                <div class="form-card p-0 shadow-none">
                                                    <h2 class="fs-title mb-5">Informasi Pelanggan</h2>
                                                    <div class="form-group">
                                                        <label for="nama">nama</label>
                                                        <input required v-model="inputNamaPelanggan" type="text"
                                                            class="form-control" name="nama" id="nama">
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="email">email</label>
                                                        <input v-model="inputEmail" type="text" class="form-control"
                                                            name="email" id="email">
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="instansi">instansi</label>
                                                        <input v-model="inputInstansi" type="text" class="form-control"
                                                            name="instansi" id="instansi">
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="telepon">telepon</label>
                                                        <input required v-model="inputTelepon" type="text"
                                                            class="form-control" name="telepon" id="telepon">
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="alamat">alamat</label>
                                                        <input required v-model="inputAlamat" type="text"
                                                            class="form-control" name="alamat" id="alamat">
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="jenis_kelamin">jenis_kelamin</label>
                                                        <select v-model="selectJenisKelamin" class="form-control"
                                                            name="jenis_kelamin" id="jenis_kelamin">
                                                            <option>laki-laki</option>
                                                            <option>perempuan</option>
                                                        </select>
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="jenis_pelanggan">jenis_pelanggan</label>
                                                        <select v-model="selectJenisPelanggan" class="form-control"
                                                            name="jenis_pelanggan" id="jenis_pelanggan">
                                                            <option>corporate</option>
                                                            <option>retail</option>
                                                        </select>
                                                    </div>
                                                </div>
                                                <input type="button" name="next" class="next action-button"
                                                    value="Lanjut" />
                                            </fieldset>
                                            <fieldset>
                                                <div class="form-card shadow-none p-0">
                                                    <h2 class="fs-title mb-5">Produk</h2>
                                                    <div class="form-group">
                                                        <label for="nama">nama</label>
                                                        <input v-model="order.nama" type="text" class="form-control"
                                                            name="nama" id="nama">
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="deskripsi">deskripsi</label>
                                                        <input v-model="order.deskripsi" type="text" class="form-control"
                                                            name="deskripsi" id="deskripsi">
                                                    </div>
                                                    <div class="form-group">
                                                        <div class="row">
                                                            <div class="col-sm-6">
                                                                <label for="bahan">Bahan</label>
                                                                <div
                                                                    class="input-wrapper d-flex flex-row justify-content-center  align-items-center">
                                                                    <input v-model="inputBahan" type="text"
                                                                        class="form-control" name="bahan" id="bahan">
                                                                    <button @click="addBahan" type="button"
                                                                        class="btn btn-primary ml-3 mb-5"><i
                                                                            class="fas fa-plus"></i>
                                                                    </button>
                                                                </div>
                                                            </div>
                                                            <div class="col-sm-6">
                                                                <p>List bahan</p>
                                                                <template v-if="order.bahan.length < 1">
                                                                    <div
                                                                        class="d-flex flex-column jutify-content-center align-items-center">
                                                                        <img src="/assets/img/empty.svg" alt="" width="80">
                                                                        <p>tambah bahan terlebih dahulu</p>
                                                                    </div>
                                                                </template>
                                                                <ul>
                                                                    <li v-for="(bahan, index) in order.bahan" :key="index">
                                                                        {{ bahan }}
                                                                        <span class="badge badge-danger ml-5"
                                                                            @click="deleteBahan(index)"><i
                                                                                class="fas fa-trash"></i></span>
                                                                    </li>
                                                                </ul>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="mesin">mesin</label>
                                                        <select v-model="order.mesin" class="form-control" name="mesin"
                                                            id="mesin">
                                                            <option>indoor</option>
                                                            <option>outdoor</option>
                                                            <option>other</option>
                                                        </select>
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="finishing">finishing</label>
                                                        <input v-model="order.finishing" type="text" class="form-control"
                                                            name="finishing" id="finishing">
                                                    </div>
                                                    <div class="form-group">
                                                        <div class="row">
                                                            <div class="col-sm-8">
                                                                <label for="jumlah">Jumlah</label>
                                                                <input v-model="order.jumlah" type="number"
                                                                    class="form-control" name="jumlah" id="jumlah">
                                                            </div>
                                                            <div class="col-sm-4">
                                                                <label for="satuan">Satuan</label>
                                                                <input v-model="order.satuan" type="text"
                                                                    class="form-control" name="satuan" id="satuan"
                                                                    placeholder="">
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="harga_satuan">harga_satuan</label>
                                                        <input v-model="order.harga_satuan" type="text" class="form-control"
                                                            name="harga_satuan" id="harga_satuan">
                                                    </div>
                                                    <div class="form-grup">
                                                        <button type="button" @click="tambahPesanan"
                                                            class="btn btn-primary">Tambah
                                                            Pesanan</button>
                                                    </div>
                                                </div>
                                                <div class="container-fluid">
                                                    <table class="table">
                                                        <thead>
                                                            <tr>
                                                                <th>nama</th>
                                                                <th>deskripsi</th>
                                                                <th>bahan</th>
                                                                <th>mesin</th>
                                                                <th>finishing</th>
                                                                <th>jumlah</th>
                                                                <th>harga satuan</th>
                                                                <th>total</th>
                                                                <th>#</th>
                                                            </tr>
                                                        </thead>
                                                        <tbody>
                                                            <tr v-for="(order, index) in orders" :key="index">
                                                                <td>{{ order.nama }}</td>
                                                                <td>{{ order.deskripsi }}</td>
                                                                <td>
                                                                    <ul>
                                                                        <li v-for="(bahan, index) in order.bahan"
                                                                            :key="index">
                                                                            {{ bahan }}
                                                                        </li>
                                                                    </ul>
                                                                </td>
                                                                <td>{{ order.mesin }}</td>
                                                                <td>{{ order.finishing }}</td>
                                                                <td>{{ order.jumlah }}</td>
                                                                <td>Rp. {{ Number(order.harga_satuan).toLocaleString() }}
                                                                </td>
                                                                <td>Rp. {{ Number(order.harga_satuan *
                                                                    order.jumlah).toLocaleString() }}</td>
                                                                <td>
                                                                    <button class="btn btn-danger" type="button"
                                                                        @click="hapusPesanan(index)"><i
                                                                            class="fas fa-trash"></i></button>
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>
                                                </div>
                                                <input type="button" name="previous" class="previous action-button-previous"
                                                    value="kembali" />
                                                <input type="button" name="next" class="next action-button"
                                                    value="Lanjut" />
                                            </fieldset>
                                            <fieldset>
                                                <div class="form-card p-0 shadow-none">
                                                    <h2 class="fs-title">Batas penyelesaian</h2>
                                                    <div class="form-group">
                                                        <label for="deadine">deadine</label>
                                                        <input v-model="inputDeadline" type="date" class="form-control"
                                                            name="deadine" id="deadine">
                                                    </div>

                                                </div>
                                                <input type="button" name="previous" class="previous action-button-previous"
                                                    value="kembali" />
                                                <input type="button" name="next" class="next action-button"
                                                    value="Lanjut" />
                                            </fieldset>
                                            <fieldset>
                                                <div class="form-card p-0 shadow-none">
                                                    <h2 class="fs-title">Pembayaran</h2>
                                                    <div class="form-group">
                                                        <label for="metode_pembayaran">metode_pembayaran</label>
                                                        <select v-model="selectMetodePembayaran" class="form-control"
                                                            name="metode_pembayaran" id="metode_pembayaran">
                                                            <option>Pembayaran dimuka</option>
                                                            <option>Pembayaran mendatang / hutang</option>
                                                        </select>
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="tgl_jatuh_tempo">tgl_jatuh_tempo</label>
                                                        <input v-model="input_tgl_jatuh_tempu" type="date"
                                                            class="form-control" name="tgl_jatuh_tempo"
                                                            id="tgl_jatuh_tempo">
                                                    </div>
                                                    <div class="form-group"
                                                        v-if="selectMetodePembayaran == 'Pembayaran dimuka'">
                                                        <label for="jenis_pembayaran">jenis_pembayaran</label>
                                                        <select v-model="selectJenisPembayaran" class="form-control"
                                                            name="jenis_pembayaran" id="jenis_pembayaran">
                                                            <option>Cash</option>
                                                            <option>Transfer</option>
                                                            <option>Other</option>
                                                        </select>
                                                    </div>
                                                    <div class="form-group"
                                                        v-if="selectMetodePembayaran == 'Pembayaran dimuka'">
                                                        <label for="jumlah_yang_dibayar">jumlah_yang_dibayar</label>
                                                        <input v-model="inputJumlahYangDibayar" type="text"
                                                            class="form-control" name="jumlah_yang_dibayar"
                                                            id="jumlah_yang_dibayar">
                                                    </div>
                                                </div>
                                                <input type="button" name="previous" class="previous action-button-previous"
                                                    value="kembali" />

                                                <!-- <input @click="confirmPesanan" type="button" name="make_payment"
                                                    class="next action-button" value="Confirm" id="btn-confirm" /> -->
                                                <input @click="confirmPesanan" type="button" name="make_payment"
                                                    class="action-button" value="Confirm" id="btn-confirm" />
                                                <template v-if="loading">
                                                    <i class="fas fa-spinner fa-spin"></i>
                                                </template>
                                            </fieldset>
                                            <fieldset id="fieldset-finish">
                                                <div class="form-card shadow-none p-0">
                                                    <h2 class="fs-title text-center">Success !</h2>
                                                    <br><br>
                                                    <div class="row justify-content-center">
                                                        <div class="col-3">
                                                            <img src="/assets/img/working.svg" class="fit-image">
                                                        </div>
                                                    </div>
                                                    <br><br>
                                                    <div class="row justify-content-center">
                                                        <div class="col-7 text-center">
                                                            <h5>Data telah berhasil disimpan !</h5>
                                                            <Link href="/pesanan">kembali</Link>
                                                        </div>
                                                    </div>
                                                </div>
                                            </fieldset>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>


    </AuthenticatedLayout>
</template>

<script>



export default {
    data() {
        return {

            loading: false,

            // deadline
            inputDeadline: '',

            // pelanggan
            inputNamaPelanggan: '',
            inputEmail: '',
            inputInstansi: '',
            inputTelepon: '',
            inputAlamat: '',
            selectJenisKelamin: '',
            selectJenisPelanggan: '',

            // pembayaran
            selectMetodePembayaran: '',
            input_tgl_jatuh_tempu: '',
            selectJenisPembayaran: '',
            inputJumlahYangDibayar: '',

            // produk
            inputNamaProduk: '',
            inputBahan: '',
            inputDeskripsi: '',
            inputMesin: '',
            inputFinishing: '',
            inputJumlah: '',
            inputSatuan: '',
            inputHargaSatuan: '',
            order: {
                nama: '',
                deskripsi: '',
                bahan: [],
                mesin: '',
                finishing: '',
                jumlah: '',
                satuan: '',
                harga_satuan: '',


            },
            orders: [],
        };
    },
    props: {
        user: Object,
        users: Object,
        absensi: Object,
    },

    methods: {
        confirmPesanan() {
            this.loading = true;
            const formData = {

                // deadline
                deadline: this.inputDeadline,

                // pelanggan
                nama_pelanggan: this.inputNamaPelanggan,
                email: this.inputEmail,
                instansi: this.inputInstansi,
                telepon: this.inputTelepon,
                alamat: this.inputAlamat,
                jenis_kelamin: this.selectJenisKelamin,
                jenis_pelanggan: this.selectJenisPelanggan,

                // pembayaran
                metode_pembayaran: this.selectMetodePembayaran,
                tgl_jatuh_tempo: this.input_tgl_jatuh_tempu,
                jenis_pembayaran: this.selectJenisPembayaran,
                jumlah_yang_dibayar: this.inputJumlahYangDibayar,

                // produk
                pesanan: this.orders,
            }
            // Send the data to the backend server using axios
            axios.post('/pesanan', formData)
                .then(response => {
                    // Handle success response
                    console.log(response);

                })
                .catch(error => {
                    // Handle error response
                    console.error(error);


                }).finally(() => {
                    $('fieldset').css('display', 'none');
                    $('#fieldset-finish').css('display', 'block');
                    $('#fieldset-finish').css('opacity', '1');
                    $('#confirm').addClass('active');
                });
        },
        tambahPesanan() {
            // You can add validation and processing here
            // Once validated, add the product object to the products array
            this.orders.push({ ...this.order });
            // Reset the product object for the next input
            this.order = {
                nama: '',
                deskripsi: '',
                bahan: [],
                mesin: '',
                finishing: '',
                jumlah: '',
                satuan: '',
                harga_satuan: '',
            };

            this.inputBahan = '';
            this.inputNamaProduk = '';
            this.inputDeskripsi = '';
            this.inputMesin = '';
            this.inputFinishing = '';
            this.inputJumlah = '';
            this.inputSatuan = '';
            this.inputHargaSatuan = '';
        },
        hapusPesanan(index) {
            this.orders.splice(index, 1);
        },
        addBahan() {
            if (this.inputBahan) {
                this.order.bahan.push(this.inputBahan);
                this.inputBahan = '';
            }
        },
        deleteBahan(index) {
            this.bahan.splice(index, 1);
        },

    }, mounted() {

        var current_fs, next_fs, previous_fs; //fieldsets
        var opacity;
        var self = this;

        $(".next").click(function () {



            if (self.inputNamaPelanggan && self.inputAlamat && self.inputTelepon) {
                current_fs = $(this).parent();
                next_fs = $(this).parent().next();

                //Add Class Active
                $("#progressbar li").eq($("fieldset").index(next_fs)).addClass("active");

                //show the next fieldset
                next_fs.show();
                //hide the current fieldset with style
                current_fs.animate({ opacity: 0 }, {
                    step: function (now) {
                        // for making fielset appear animation
                        opacity = 1 - now;

                        current_fs.css({
                            'display': 'none',
                            'position': 'relative'
                        });
                        next_fs.css({ 'opacity': opacity });
                    },
                    duration: 600
                });
            } else {
                var requiredInputs = $('input[required]');

                requiredInputs.each(function () {
                    var $input = $(this);
                    if (!$input.next('.text-danger').length) {
                        $input.addClass('error-input');
                        $input.after('<small class="text-danger">harus di isi</small>');
                    }
                });
            }
        });

        $(".previous").click(function () {

            current_fs = $(this).parent();
            previous_fs = $(this).parent().prev();

            //Remove class active
            $("#progressbar li").eq($("fieldset").index(current_fs)).removeClass("active");

            //show the previous fieldset
            previous_fs.show();

            //hide the current fieldset with style
            current_fs.animate({ opacity: 0 }, {
                step: function (now) {
                    // for making fielset appear animation
                    opacity = 1 - now;

                    current_fs.css({
                        'display': 'none',
                        'position': 'relative'
                    });
                    previous_fs.css({ 'opacity': opacity });
                },
                duration: 600
            });
        });

        $('.radio-group .radio').click(function () {
            $(this).parent().find('.radio').removeClass('selected');
            $(this).addClass('selected');
        });

        $(".submit").click(function () {
            return false;
        })

        // Import a JavaScript file dynamically
        // import('./../../multistep.js')
        //     .then((module) => {
        //         // Use the imported module
        //         // For example, call a function from the module
        //         module.multistep();
        //     })
        //     .catch((error) => {
        //         console.error('Failed to load module:', error);
        //     });
        // Initialize DataTables
        $('#dataTable').DataTable({
            // DataTables configuration options
        });
    }
}
</script>
